![Glyphr Studio Logo](img/glyphr_studio_logo_b_376x116.png)


# Welcome to Glyphr Studio!
 Glyphr Studio is a free, web based font designer, focusing on font design for hobbyists.
 More information can be found at [glyphrstudio.com](http://glyphrstudio.com) - and/or
 follow [@glyphrstudio](https://twitter.com/glyphrstudio) on twitter.

### Major Features
- Vector editing tools, like a Pen Tool for path outlines and a Pointer Tool for adjusting shapes.
- Full Unicode ([BMP](https://en.wikipedia.org/wiki/Plane_(Unicode)#Basic_Multilingual_Plane)) support for Glyphs.  Define Class-based Kern Values, Ligatures, and Components.
- Import and Export Open Type fonts, True Type fonts, and SVG Fonts.
- Test Drive environment to try out your font.
- Help & Documentation
- See what's new on the [Updates Page](http://help.glyphrstudio.com/overview_updates.html).

## Links
| Website | [glyphrstudio.com](http://www.glyphrstudio.com) |
| :---- | :---- |
| App | [glyphrstudio.com/online](http://www.glyphrstudio.com/online) |
| Email | [mail@glyphrstudio.com](mailto:mail@glyphrstudio.com) |
| Twitter | [@glyphrstudio](https://twitter.com/glyphrstudio) |
| Blog | [glyphrstudio.com/blog](http://www.glyphrstudio.com/blog/) |
| Help & Documentation | [help.glyphrstudio.com](http://help.glyphrstudio.com/) |
| Help Repository | [github.com/mattlag/Glyphr-Studio-Help](https://github.com/mattlag/Glyphr-Studio-Help/) |
| Feedback | [glyphrstudio.uservoice.com](https://glyphrstudio.uservoice.com) |


## Feedback
 Feel free to get in touch with us via email or twitter or whatever, we always love talking
 to people. There is kind of a running list of feature ideas (and bugs, of course) over at the
 [Issues List]( https://github.com/mattlag/Glyphr-Studio/issues?labels=&page=1&state=open).

## Contributing
 I'm an interaction designer by trade, and have decided to use Glyphr Studio as a giant crash
 course in JavaScript and HTML5.  Since this is my first major HTML5/JS app, there are many
 opportunities for growth & improvement - for both code, and collaborative development styles.

 If you'd like to contribute a feature or bug fix, please make sure to search the issue tracker
 first, your issue may have already been discussed or fixed in master.  After researching, please
 feel free to fork and send a pull request.

## License
 Copyright (C) 2010 - 2020 Matthew LaGrandeur, released under
 [GPL 3.0](https://github.com/mattlag/Glyphr-Studio/blob/master/LICENSE-gpl-3.0.txt)

## Author
| ![Matthew LaGrandeur's picture](https://1.gravatar.com/avatar/f6f7b963adc54db7e713d7bd5f4903ec?s=70) |
|---|
| [Matthew LaGrandeur](http://mattlag.com/) |
| matt[at]mattlag[dot]com |


## Thanks!
For cross-browser testing, we use

[![BrowserStack](/img/browserstack-logo-31.png )](http://browserstack.com)
